using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Bus_Feedback
    /// </summary>
    public partial class T_Bus_Feedback
    {
        public T_Bus_Feedback()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Bus_Feedback");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
		/// 增加一条数据
		/// </summary>
		public int Add(CallCenterApi.Model.T_Bus_Feedback model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Bus_Feedback(");
            strSql.Append("F_AssignedId,F_WorkOrderId,F_Result,F_CreateTime,F_CreateUser,F_CreateDeptId,F_IsFeedEnd,F_File,F_Type,F_State,F_IsAudit,F_AuditUser,F_AuditTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_DealUser,F_AuditReason)");
            strSql.Append(" values (");
            strSql.Append("@F_AssignedId,@F_WorkOrderId,@F_Result,@F_CreateTime,@F_CreateUser,@F_CreateDeptId,@F_IsFeedEnd,@F_File,@F_Type,@F_State,@F_IsAudit,@F_AuditUser,@F_AuditTime,@F_IsDelete,@F_DeleteUser,@F_DeleteTime,@F_DealUser,@F_AuditReason)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AssignedId", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateDeptId", SqlDbType.Int,4),
                    new SqlParameter("@F_IsFeedEnd", SqlDbType.Int,4),
                    new SqlParameter("@F_File", SqlDbType.VarChar,500),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_IsAudit", SqlDbType.Int,4),
                    new SqlParameter("@F_AuditUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_AuditTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DealUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AuditReason", SqlDbType.NVarChar,-1)};
            parameters[0].Value = model.F_AssignedId;
            parameters[1].Value = model.F_WorkOrderId;
            parameters[2].Value = model.F_Result;
            parameters[3].Value = model.F_CreateTime;
            parameters[4].Value = model.F_CreateUser;
            parameters[5].Value = model.F_CreateDeptId;
            parameters[6].Value = model.F_IsFeedEnd;
            parameters[7].Value = model.F_File;
            parameters[8].Value = model.F_Type;
            parameters[9].Value = model.F_State;
            parameters[10].Value = model.F_IsAudit;
            parameters[11].Value = model.F_AuditUser;
            parameters[12].Value = model.F_AuditTime;
            parameters[13].Value = model.F_IsDelete;
            parameters[14].Value = model.F_DeleteUser;
            parameters[15].Value = model.F_DeleteTime;
            parameters[16].Value = model.F_DealUser;
            parameters[17].Value = model.F_AuditReason;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Bus_Feedback model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Bus_Feedback set ");
            strSql.Append("F_AssignedId=@F_AssignedId,");
            strSql.Append("F_WorkOrderId=@F_WorkOrderId,");
            strSql.Append("F_Result=@F_Result,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_CreateDeptId=@F_CreateDeptId,");
            strSql.Append("F_IsFeedEnd=@F_IsFeedEnd,");
            strSql.Append("F_File=@F_File,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_IsAudit=@F_IsAudit,");
            strSql.Append("F_AuditUser=@F_AuditUser,");
            strSql.Append("F_AuditTime=@F_AuditTime,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_DeleteUser=@F_DeleteUser,");
            strSql.Append("F_DeleteTime=@F_DeleteTime,");
            strSql.Append("F_DealUser=@F_DealUser,");
            strSql.Append("F_AuditReason=@F_AuditReason");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AssignedId", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateDeptId", SqlDbType.Int,4),
                    new SqlParameter("@F_IsFeedEnd", SqlDbType.Int,4),
                    new SqlParameter("@F_File", SqlDbType.VarChar,500),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_IsAudit", SqlDbType.Int,4),
                    new SqlParameter("@F_AuditUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_AuditTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DealUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AuditReason", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_AssignedId;
            parameters[1].Value = model.F_WorkOrderId;
            parameters[2].Value = model.F_Result;
            parameters[3].Value = model.F_CreateTime;
            parameters[4].Value = model.F_CreateUser;
            parameters[5].Value = model.F_CreateDeptId;
            parameters[6].Value = model.F_IsFeedEnd;
            parameters[7].Value = model.F_File;
            parameters[8].Value = model.F_Type;
            parameters[9].Value = model.F_State;
            parameters[10].Value = model.F_IsAudit;
            parameters[11].Value = model.F_AuditUser;
            parameters[12].Value = model.F_AuditTime;
            parameters[13].Value = model.F_IsDelete;
            parameters[14].Value = model.F_DeleteUser;
            parameters[15].Value = model.F_DeleteTime;
            parameters[16].Value = model.F_DealUser;
            parameters[17].Value = model.F_AuditReason;
            parameters[18].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_Feedback ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_Feedback ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_Feedback GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_AssignedId,F_WorkOrderId,F_Result,F_CreateTime,F_CreateUser,F_CreateDeptId,F_IsFeedEnd,F_File,F_Type,F_State,F_IsAudit,F_AuditUser,F_AuditTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_DealUser,F_AuditReason from T_Bus_Feedback ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Bus_Feedback model = new CallCenterApi.Model.T_Bus_Feedback();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_Feedback DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Bus_Feedback model = new CallCenterApi.Model.T_Bus_Feedback();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_AssignedId"] != null && row["F_AssignedId"].ToString() != "")
                {
                    model.F_AssignedId = int.Parse(row["F_AssignedId"].ToString());
                }
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["F_Result"] != null)
                {
                    model.F_Result = row["F_Result"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_CreateDeptId"] != null && row["F_CreateDeptId"].ToString() != "")
                {
                    model.F_CreateDeptId = int.Parse(row["F_CreateDeptId"].ToString());
                }
                if (row["F_IsFeedEnd"] != null && row["F_IsFeedEnd"].ToString() != "")
                {
                    model.F_IsFeedEnd = int.Parse(row["F_IsFeedEnd"].ToString());
                }
                if (row["F_File"] != null)
                {
                    model.F_File = row["F_File"].ToString();
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_IsAudit"] != null && row["F_IsAudit"].ToString() != "")
                {
                    model.F_IsAudit = int.Parse(row["F_IsAudit"].ToString());
                }
                if (row["F_AuditUser"] != null)
                {
                    model.F_AuditUser = row["F_AuditUser"].ToString();
                }
                if (row["F_AuditTime"] != null && row["F_AuditTime"].ToString() != "")
                {
                    model.F_AuditTime = DateTime.Parse(row["F_AuditTime"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_DeleteUser"] != null)
                {
                    model.F_DeleteUser = row["F_DeleteUser"].ToString();
                }
                if (row["F_DeleteTime"] != null && row["F_DeleteTime"].ToString() != "")
                {
                    model.F_DeleteTime = DateTime.Parse(row["F_DeleteTime"].ToString());
                }
                if (row["F_DealUser"] != null)
                {
                    model.F_DealUser = row["F_DealUser"].ToString();
                }
                if (row["F_AuditReason"] != null)
                {
                    model.F_AuditReason = row["F_AuditReason"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_AssignedId,F_WorkOrderId,F_Result,F_CreateTime,F_CreateUser,F_CreateDeptId,F_IsFeedEnd,F_File,F_Type,F_State,F_IsAudit,F_AuditUser,F_AuditTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_DealUser,F_AuditReason ");
            strSql.Append(" FROM T_Bus_Feedback ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_AssignedId,F_WorkOrderId,F_Result,F_CreateTime,F_CreateUser,F_CreateDeptId,F_IsFeedEnd,F_File,F_Type,F_State,F_IsAudit,F_AuditUser,F_AuditTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_DealUser,F_AuditReason ");
            strSql.Append(" FROM T_Bus_Feedback ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Bus_Feedback ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Bus_Feedback T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 根据工单编号得到一个最新对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_Feedback GetNewModelByWorkOrderID(string F_WorkOrderId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Bus_Feedback ");
            strSql.Append(" where F_WorkOrderId=@F_WorkOrderId and F_IsDelete=0");
            strSql.Append(" order by F_Id desc");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20)
            };
            parameters[0].Value = F_WorkOrderId;

            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]); ;
            }
            else
            {
                return null;
            }
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Bus_Feedback";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

